open Tk;;

let top = openTk ();;

let w = 400 and h = 300;;

let c =
  Canvas.create top
    [Width (Pixels w); Height (Pixels h)];;

let load_image filename =
  let photo = Imagephoto.create [File filename] in
  let w = Imagephoto.width photo
  and h = Imagephoto.height photo in
  let img =
    Canvas.create_image c (Pixels w) (Pixels h)
     [ImagePhoto photo; Anchor NW; Tags [Tag "img"]] in
  Canvas.coords_set c img [Pixels 0; Pixels 0];
  img, w, h;;

let imgs =
  List.map load_image ["CamlBook.gif"; "dojoji.gif"; "seize.gif"];;

let get_coords c img =
  match Canvas.coords_get c img with
  | [x0; y0] -> int_of_float x0, int_of_float y0
  | _ -> assert false;;

let on_img x y c (img, w, h) =
  let x0, y0 = get_coords c img in
  x0 <= x && x <= x0 + w &&
  y0 <= y && y <= y0 + h;;

let img_of c x y = List.find (on_img x y c) imgs;;

let move img (tx, ty) ei =
  Canvas.coords_set c img
   [Pixels (ei.ev_MouseX + tx);
    Pixels (ei.ev_MouseY + ty)];;

let rec get ei =
  let x, y = ei.ev_MouseX, ei.ev_MouseY in
  let img, _, _ = img_of c x y in
  let img_x, img_y = get_coords c img in
  let t = img_x - x, img_y - y in
  Canvas.bind c (Tag "img") [[], ButtonRelease]
    (BindSet ([Ev_MouseX; Ev_MouseY], release));
  Canvas.bind c (Tag "img") [[], Motion]
    (BindSet
      ([Ev_MouseX; Ev_MouseY],
       move img t))

 and release ei =
  Canvas.bind c (Tag "img") [[], ButtonPress]
    (BindSet ([Ev_MouseX; Ev_MouseY], get));
  Canvas.bind c (Tag "img") [[], Motion]
     (BindSet ([Ev_MouseX; Ev_MouseY], (fun _ -> ())));;

Canvas.bind c (Tag "img") [[], ButtonPress]
 (BindSet ([Ev_MouseX; Ev_MouseY], get));;
pack [c] [];;

mainLoop ();;
