open Tk;;

let sub_image img x y w h =
  let result =
    Imagephoto.create
      [Width (Pixels w); Height (Pixels h)] in
  Imagephoto.copy result img
    [ImgFrom (x, y, x + w, y + h)];
  result;;

let load_image filename =
  let img = Imagephoto.create [File filename] in
  let w = Imagephoto.width img
  and h = Imagephoto.height img in
  img, w, h;;

let display_image filename c =
  let img, w, h = load_image filename in
  let gobj =
   Canvas.create_image c (Pixels w) (Pixels h)
    [ImagePhoto img; Anchor NW; Tags [Tag "img"]] in
  w, h, gobj;;

let prog fp filename =
  let img, w, h = load_image filename in
  let c =
    Canvas.create fp
     [Width (Pixels w); Height (Pixels h)] in
  Canvas.create_image c (Pixels w) (Pixels h)
    [ImagePhoto img; Anchor SE];
  pack [c] [];;

let top = openTk ();;
prog top "figure-3a.gif";;
mainLoop ();;
