open Tk;;

let main_window = openTk ();;

let make_scale_255 wid name =
  Scale.create wid
    [Label name; From 0.0; To 255.0;
     Length (Centimeters 10.0); Orient Horizontal;
     Foreground White];;

let red, green, blue =
 make_scale_255 main_window "Red",
 make_scale_255 main_window "Green",
 make_scale_255 main_window "Blue";;

let pattern =
  Frame.create main_window
  [Height(Centimeters 1.5); Width(Centimeters 6.0)];;

let quit =
  Button.create main_window
   [Text "Quit"; Command closeTk];;

let tk_color_of_rgb r g b =
  NamedColor (Printf.sprintf "#%02x%02x%02x" r g b);;

let configure_scales r g b =
  let configure_scale sc r g b =
    Scale.configure sc
      [Background (tk_color_of_rgb r g b)] in
  configure_scale red r 0 0;
  configure_scale green 0 g 0;
  configure_scale blue 0 0 b;;

let set_color _ =
  let r = int_of_float (Scale.get red)
  and g = int_of_float (Scale.get green)
  and b = int_of_float (Scale.get blue) in
  configure_scales r g b;
  let color = tk_color_of_rgb r g b in 
  Frame.configure pattern [Background color];;

Wm.title_set main_window "Choose a color";;

Scale.configure red [ScaleCommand set_color];
Scale.configure green [ScaleCommand set_color];
Scale.configure blue [ScaleCommand set_color];
pack [red; green; blue] [Side Side_Top];
pack [quit] [Side Side_Bottom];
pack [pattern] [Side Side_Bottom; PadY(Millimeters 2.0)];
mainLoop ();;
